/*
      2@ 02

  2003/ 6/ 6 ˁ@P
*/

#include <windows.h>
#include <vfw.h>
#include <vector>
#include <string>

#define IDM_EXIT 1
#define IDM_CONNECT 11
#define IDM_SOURCE 12
#define IDM_FORMAT 13
#define IDM_RESIZE 14
#define IDM_INFO 21
#define IDM_ABOUT 22
#define IDM_JUMP 23

using namespace std;

struct VideoDevice {

	int iNo;
	char lpszName[80], lpszVersion[80];

};

HINSTANCE hInst;
HWND hwMain, hwCap;
BITMAPINFOHEADER biVideo;
int iSWidth, iSHeight, iWWidth, iWHeight, iDrvNum=0, iDrvNow=-1;
HMENU hMenu, hMenuFile, hMenuDef, hMenuAbout;
CAPDRIVERCAPS ccDriver;
vector<VideoDevice> vvdDevice; 

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ConnectDialogProc(HWND, UINT, WPARAM, LPARAM);
bool initDriver(int iArg);
bool connect();

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow){

	MSG  msg;
	WNDCLASSEX wndclass;
	VideoDevice vdTmp;

	hInst=hInstance; /* vZX̃nhۑ */

	for (int i = 0;i <= 9;i++) /* rfILv`hCo */
		if (capGetDriverDescription(i, vdTmp.lpszName, 80, vdTmp.lpszVersion, 80)) {

			vdTmp.iNo = i;

			vvdDevice.push_back(vdTmp);
			iDrvNum++;

		}

	if (iDrvNum < 1) {

		MessageBox(NULL, "LȃrfILv`hCo܂łB", "G[", MB_OK);

		return 0;

	}

	/* CEChEpEChENXݒ */
	wndclass.cbSize        = sizeof(wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(hInstance,"IDI_ICON1");
	wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "CWindow";
	wndclass.hIconSm       = LoadIcon(hInstance,"IDI_ICON1");

	RegisterClassEx(&wndclass); /* EChENXo^ */

	/* hCoI_CAOpEChENXݒ */
	wndclass.cbSize        = sizeof(wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = ConnectDialogProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(hInstance,"IDI_ICON1");
	wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "CConnectDialog";
	wndclass.hIconSm       = LoadIcon(hInstance,"IDI_ICON1");

	RegisterClassEx(&wndclass); /* EChENXo^ */

	hwMain = CreateWindow("CWindow", "2@",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT,
	  512, 512, NULL, NULL, hInstance, NULL);

	/* j[쐬 */
	hMenu = CreateMenu();
	hMenuFile = CreateMenu();
	hMenuDef = CreateMenu();
	hMenuAbout = CreateMenu();

	AppendMenu(hMenuFile, MF_STRING, IDM_EXIT, "I(&Xj");

	AppendMenu(hMenuDef, MF_STRING, IDM_CONNECT, "rfhCoڑ(&Cj");
	AppendMenu(hMenuDef, MF_STRING, IDM_SOURCE, "rfI\[Xݒ(&Sj");
	AppendMenu(hMenuDef, MF_STRING, IDM_FORMAT, "rfItH[}bgݒ(&Fj");
	AppendMenu(hMenuDef, MF_STRING, IDM_RESIZE, "ʃTCYZbg(&Rj");

	AppendMenu(hMenuAbout, MF_STRING, IDM_INFO, "foCX(&Dj");
	AppendMenu(hMenuAbout, MF_STRING, IDM_ABOUT, "o[W(&Aj");
	AppendMenu(hMenuAbout, MF_STRING, IDM_JUMP, "҃TCgunvO~O̊Xv(&Gj");

	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuFile, "t@Ci&Fj");
	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuDef, "ݒi&Dj");
	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuAbout, "i&Ij");

	/* EChEɃj[ݒ */
	SetMenu(hwMain, hMenu);

	initDriver(0);

	while (GetMessage(&msg, NULL, 0, 0)) { /* bZ[W[v */

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	return msg.wParam;

}

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	int s, w, h;
	RECT rec;
	char lpszTmp[512];

	switch (iMsg) {

	case WM_CREATE:

		hwCap = capCreateCaptureWindow("cap", WS_BORDER | WS_VISIBLE | WS_CHILD, 0, 0, 320, 240, hwnd, 0);

		return 0;

	case WM_SIZE:

		/* NCAg̈W擾 */
		GetClientRect(hwnd, &rec);

		/* ݂̃EChETCYۑ */
		iWWidth = rec.right - rec.left;
		iWHeight = rec.bottom - rec.top;

		/* Lv`EChENCAg̈̑傫ɍ킹 */
		SetWindowPos(hwCap, HWND_TOP, 0, 0, iWWidth, iWHeight, SWP_NOMOVE | SWP_NOZORDER);

		return 0;

	case WM_INITMENUPOPUP:

		if (lParam == 1 && ccDriver.fHasDlgVideoSource) {
			EnableMenuItem((HMENU)wParam, IDM_SOURCE, MF_ENABLED);
		} else {
			EnableMenuItem((HMENU)wParam, IDM_SOURCE, MF_GRAYED);
		}

		if (lParam == 1 && ccDriver.fHasDlgVideoFormat) {
			EnableMenuItem((HMENU)wParam, IDM_FORMAT, MF_ENABLED);
		} else {
			EnableMenuItem((HMENU)wParam, IDM_FORMAT, MF_GRAYED);
		}

		return 0;

	case WM_COMMAND:

		switch (LOWORD(wParam)) {

		case IDM_EXIT: /* I */
			
			DestroyWindow(hwMain);

			break;

		case IDM_CONNECT: /* hCoڑ */
			
			connect();

			break;

		case IDM_SOURCE: /* rfI\[Xݒ */

			if(!capDlgVideoSource(hwCap)) {
				break;
			}

			s = capGetVideoFormatSize(hwCap);

			capGetVideoFormat(hwCap, &biVideo, s);

			/* rfI\[XTCYύXꂽAEChETCY */
			if (iSWidth != biVideo.biWidth || iSHeight != biVideo.biHeight) {

				/* Lv`t[TCYۑ */
				iSWidth = biVideo.biWidth;
				iSHeight = biVideo.biHeight;

				rec.left = 0;
				rec.top = 0;
				rec.right = iSWidth;
				rec.bottom = iSHeight;

				AdjustWindowRect(&rec, WS_OVERLAPPEDWINDOW, true);

				w = rec.right - rec.left;
				h = rec.bottom - rec.top;

				SetWindowPos(hwnd, HWND_TOP, 0, 0, w, h, SWP_NOMOVE);

			}

			break;

		case IDM_FORMAT: /* rfItH[}bgݒ */

			if(!capDlgVideoFormat(hwCap)) {
				break;
			}

			s = capGetVideoFormatSize(hwCap);

			capGetVideoFormat(hwCap, &biVideo, s);

			/* rfI\[XTCYύXꂽAEChETCY */
			if (iSWidth != biVideo.biWidth || iSHeight != biVideo.biHeight) {

				/* Lv`t[TCYۑ */
				iSWidth = biVideo.biWidth;
				iSHeight = biVideo.biHeight;

				rec.left = 0;
				rec.top = 0;
				rec.right = iSWidth;
				rec.bottom = iSHeight;

				/* EChEŜ̃TCYvZ */
				AdjustWindowRect(&rec, WS_OVERLAPPEDWINDOW, TRUE);

				w = rec.right - rec.left;
				h = rec.bottom - rec.top;

				/* EChETCYύX */
				SetWindowPos(hwnd, HWND_TOP, 0, 0, w, h, SWP_NOMOVE);

			}

			break;

		case IDM_RESIZE: /* 𑜓xZbg */

			/* EChETCYƃt[TCYقȂ鎞͈v */
			if (iSWidth != iWWidth || iSHeight != iWHeight) {

				rec.left = 0;
				rec.top = 0;
				rec.right = iSWidth;
				rec.bottom = iSHeight;

				/* EChEŜ̃TCYvZ */
				AdjustWindowRect(&rec, WS_OVERLAPPEDWINDOW, TRUE);

				w = rec.right - rec.left;
				h = rec.bottom - rec.top;
				
				/* EChETCYύX */
				SetWindowPos(hwnd, HWND_TOP, 0, 0, w, h, SWP_NOMOVE);

			}

			break;

		case IDM_INFO: /* foCX */

			wsprintf(lpszTmp, "hCoF%s %s\r\nrfI\[XTCYF%d~%dsNZ\r\n\TCYF%d~%dsNZ\r\n",
			         vvdDevice[iDrvNow]. lpszName, vvdDevice[iDrvNow]. lpszVersion, iSWidth, iSHeight, iWWidth, iWHeight);

			MessageBox(hwMain, lpszTmp, "foCX", MB_OK);

			break;

		case IDM_ABOUT: /* o[W */

			MessageBox(hwMain,"2@ 02(C)2002-2003 ˁ@P","o[W",MB_OK);

			break;

		case IDM_JUMP: /* nvO~O̊X */

			ShellExecute(NULL,"open","http://www.sm.rim.or.jp/~shishido/", 
			  NULL,NULL,SW_SHOWNORMAL);

			break;

		}

		return 0;

	case WM_DESTROY : /* I */

		capDriverDisconnect(hwCap);

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc(hwnd,iMsg,wParam,lParam);

}

bool initDriver(int iArg) { /* hCoڑ */

	RECT rec;
	int w, h, s;

	if (iDrvNow != -1) {
		capDriverDisconnect(hwCap);
	}

	iDrvNow = iArg;

	capDriverConnect(hwCap, vvdDevice[iDrvNow].iNo);

	capPreviewScale(hwCap, true);
	capPreviewRate(hwCap, 30);
	capPreview(hwCap, true);

	capDriverGetCaps(hwCap, &ccDriver, sizeof(CAPDRIVERCAPS));

	s = capGetVideoFormatSize(hwCap);

	capGetVideoFormat(hwCap, &biVideo, s);

	iSWidth = biVideo.biWidth;
	iSHeight = biVideo.biHeight;

	rec.left = 0;
	rec.top = 0;
	rec.right = iSWidth;
	rec.bottom = iSHeight;

	AdjustWindowRect(&rec, WS_OVERLAPPEDWINDOW, true);

	w = rec.right - rec.left;
	h = rec.bottom - rec.top;

	/* EChẼNCAg̈TCYrfI\[XTCYɍ킹 */
	SetWindowPos(hwMain, HWND_TOP, 0, 0, w, h, SWP_NOMOVE);

	return true;

}

bool connect() { /* hCoڑ_CAO */

	HWND hwDialog;
	static DWORD dwDone;
	MSG msg;

	dwDone = 0;

	/* _CAO{bNX쐬 */
	hwDialog=CreateWindow("CConnectDialog", "hCoڑ",
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE, CW_USEDEFAULT, CW_USEDEFAULT,
	  360, 200, NULL, NULL, hInst, NULL);

	/* _CAÕEChEvV[W|ɃtOϐ̃AhXn */
	ConnectDialogProc(NULL, (UINT)(&dwDone), 0, 0);

	/* CEChE𖳌ă[_ */
	EnableWindow(hwMain, false);

	/* _CAOEChEbZ[W[v */
	while (dwDone == 0) { /* _CAOʂԂ܂Ń[v */

		GetMessage(&msg, NULL, 0, 0);

		if (!IsDialogMessage(hwDialog, &msg)) {

			TranslateMessage(&msg);
			DispatchMessage(&msg);

		}

	}

	/*[_ */
	EnableWindow(hwMain, true);
	BringWindowToTop(hwMain);

	if (dwDone == 1) {
		return true;
	} else {
		return false;
	}

}

LRESULT CALLBACK ConnectDialogProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam) {

	static HWND hwLabel, hwMenu, hwOK, hwCansel;
	static LPDWORD lpDone = NULL;
	int i;

	if (hwnd == NULL) {

		/*ʕϐ̃AhXۑ */
		lpDone = (LPDWORD)iMsg;

		return 0;

	}

	switch (iMsg) {

		case WM_CREATE:

			hwLabel = CreateWindow("STATIC", "hCo", WS_CHILD|WS_VISIBLE,
			      4, 2, 64, 24, hwnd, (HMENU)2, hInst, NULL);

			hwMenu = CreateWindow("COMBOBOX", NULL, WS_CHILD|WS_VISIBLE | CBS_DROPDOWN|WS_TABSTOP,
			  4, 32, 320, iDrvNum * 20 + 80, hwnd, (HMENU)0, hInst, NULL);

			for (i = 0;i < iDrvNum;i++) { /* hCoI쐬 */
				SendMessage(hwMenu, CB_ADDSTRING, -1, (LPARAM)vvdDevice[i].lpszName);
			}

			SendMessage(hwMenu, CB_SETCURSEL, iDrvNow, iDrvNow + 1);
 
			hwOK = CreateWindow("BUTTON", "s", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			  16, 64, 72, 32, hwnd, (HMENU)1, hInst, NULL);

			hwCansel = CreateWindow("BUTTON", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			  100, 64, 72, 32, hwnd, (HMENU)2, hInst, NULL);

			return 0;

		case WM_CTLCOLORSTATIC: /* x̔wiFݒ */

			return (LRESULT)GetStockObject(WHITE_BRUSH);

		case WM_COMMAND:

			switch (LOWORD(wParam)) {

			case 1: /*s{^ */

				iDrvNow = SendMessage(hwMenu, CB_GETCURSEL, 0, 0);
				initDriver(iDrvNow);

				*lpDone = 1;

				DestroyWindow(hwnd);

				break;

			case 2: /*{^ */

				DestroyWindow(hwnd);

				break;

			}

			return 0;

		case WM_DESTROY:

				if (*lpDone != 1) {
					*lpDone=2;
				}

				break;

	}

	return DefWindowProc(hwnd, iMsg, wParam, lParam) ;

}
